"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var querystring_1 = __importDefault(require("querystring"));
/** Make an Array that can be sparse, i.e. have unfilled space. */
function createSparseArray(length, insertIndex) {
    var initialData = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        initialData[_i - 2] = arguments[_i];
    }
    var sparseArray = Array(length).slice();
    initialData.forEach(function (datum, i) { return (sparseArray[i + insertIndex] = datum); });
    return sparseArray;
}
exports.createSparseArray = createSparseArray;
/**
 * Merge query maps into one big query map, concatenating values at common
 * keys together into an Array.
 */
function mergeQueryMaps() {
    var queries = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        queries[_i] = arguments[_i];
    }
    return querystring_1.default.parse(queries.map(function (query) { return querystring_1.default.stringify(query); }).join("&"));
}
exports.mergeQueryMaps = mergeQueryMaps;
function toArray(value) {
    return value instanceof Array ? value : [value];
}
exports.toArray = toArray;
